JUCE: DirectoryIterator Class Reference

JUCE

Public Member Functions | List of all members
DirectoryIterator Class Referencefinal

Searches through the files in a directory, returning each file that is found. More...

## Public Member Functions
| DirectoryIterator (const File &directory, bool isRecursive, const String &wildCard="*", int whatToLookFor=File::findFiles)
| Creates a DirectoryIterator for a given directory. More...
| ~DirectoryIterator ()
| Destructor. More...
bool | next ()
| Moves the iterator along to the next file. More...
bool | next (bool *isDirectory, bool *isHidden, int64 *fileSize, Time *modTime, Time *creationTime, bool *isReadOnly)
| Moves the iterator along to the next file, and returns various properties of that file. More...
const File & | getFile () const
| Returns the file that the iterator is currently pointing at. More...
float | getEstimatedProgress () const
| Returns a guess of how far through the search the iterator has got. More...

## Detailed Description

Searches through the files in a directory, returning each file that is found.

A DirectoryIterator will search through a directory and its subdirectories using a wildcard filepattern match.

If you may be scanning a large number of files, it's usually smarter to use this class than File::findChildFiles() because it allows you to stop at any time, rather than having to wait for the entire scan to finish before getting the results.

Please note that the order in which files are returned is completely undefined! They'll arrive in whatever order the underlying OS calls provide them, which will depend on the filesystem and other factors. If you need a sorted list, you'll need to manually sort them using your preferred comparator after collecting the list.

It also provides an estimate of its progress, using a (highly inaccurate!) algorithm.

## Constructor & Destructor Documentation

## ◆ DirectoryIterator()

DirectoryIterator::DirectoryIterator | ( | const File & | directory,
|  | bool | isRecursive,
|  | const String & | wildCard = `"*"`,
|  | int | whatToLookFor = `File::findFiles`
| ) |  |

Creates a DirectoryIterator for a given directory.

After creating one of these, call its next() method to get the first file - e.g.

DirectoryIterator iter (File ("/animals/mooses"), true, "*.moose");
while (iter.next())
{
File theFileItFound (iter.getFile());
... etc
}

Parameters

  directory | the directory to search in
  isRecursive | whether all the subdirectories should also be searched
  wildCard | the file pattern to match. This may contain multiple patterns separated by a semi-colon or comma, e.g. "*.jpg;*.png"
  whatToLookFor | a value from the File::TypesOfFileToFind enum, specifying whether to look for files, directories, or both.

## ◆ ~DirectoryIterator()

DirectoryIterator::~DirectoryIterator | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ next() [1/2]

bool DirectoryIterator::next | ( |  | ) |

Moves the iterator along to the next file.

Returns
  true if a file was found (you can then use getFile() to see what it was) - or false if there are no more matching files.

## ◆ next() [2/2]

bool DirectoryIterator::next | ( | bool * | isDirectory,
|  | bool * | isHidden,
|  | int64 * | fileSize,
|  | Time * | modTime,
|  | Time * | creationTime,
|  | bool * | isReadOnly
| ) |  |

Moves the iterator along to the next file, and returns various properties of that file.

If you need to find out details about the file, it's more efficient to call this method than to call the normal next() method and then find out the details afterwards.

All the parameters are optional, so pass null pointers for any items that you're not interested in.

Returns
  true if a file was found (you can then use getFile() to see what it was) - or false if there are no more matching files. If it returns false, then none of the parameters will be filled-in.

## ◆ getFile()

const File& DirectoryIterator::getFile | ( |  | ) | const

Returns the file that the iterator is currently pointing at.

The result of this call is only valid after a call to next() has returned true.

## ◆ getEstimatedProgress()

float DirectoryIterator::getEstimatedProgress | ( |  | ) | const

Returns a guess of how far through the search the iterator has got.

Returns
  a value 0.0 to 1.0 to show the progress, although this won't be very accurate.

The documentation for this class was generated from the following file:

- juce_DirectoryIterator.h

File
Represents a local file or directory.
Definition: juce_File.h:41
DirectoryIterator
Searches through the files in a directory, returning each file that is found.
Definition: juce_DirectoryIterator.h:47